<?php

/**
 * Override for Magento's Catalog REST API
 */
class KOMPAX_iVend_Model_Api2_Category_Rest_Admin_V1 extends Mage_Api2_Model_Resource {

	/**
	 * Retrieve the category
	 * @return category entity
	 */
    protected function _retrieve() {
    	$category = Mage::getModel('catalog/category');
        $category->setStoreId($this->getRequest()->getParam('store'));

        $categoryId = $this->getRequest()->getParam('id');
        $category->load($categoryId);

        if (! $category->getId()) {
            $this->_critical(self::RESOURCE_NOT_FOUND);
        }

        return $category->getData();
    }

    /**
     * Retrieves the category collection and returns
     *
     * @return int
     */
     protected function _retrieveCollection() {
        $categories = Mage::getResourceModel('catalog/category_collection');
        $categories->setStoreId($this->getRequest()->getParam('store'));
		
        if (($parentId = $this->getRequest()->getParam('parent'))) {
            $categories->addAttributeToFilter('parent_id', $parentId);
        }
		
        $categories->addAttributeToSelect(array_keys(
            $this->getAvailableAttributes($this->getUserType(), Mage_Api2_Model_Resource::OPERATION_ATTRIBUTE_READ)
        ));
		
        $this->_applyCollectionModifiers($categories);
		
        $data = $categories->load()->toArray();
		return isset($data['items']) ? $data['items'] : $data;
    }
}
