<?php

/**
 * Override for Magento's Order REST API
 */
class KOMPAX_iVend_Model_Api2_Order_Rest_Admin_V1 extends Mage_Api2_Model_Resource {

	/**
     * Change status order
     *
     */
    protected function _update($data) {
	
		$order = Mage::getModel('sales/order');
        $order->setStoreId($this->getRequest()->getParam('store'));
        $orderId = $this->getRequest()->getParam('id');
        $order->load($orderId);

        if (! $order->getId()) {
            $this->_critical(self::RESOURCE_NOT_FOUND);
        }

		$state = $this->getState($data['status_name']);
		if (is_null($state)) {
			$this->_critical(self::RESOURCE_DATA_INVALID);
		}
		
		$order->setState($state, true);
		$order->save();
    
	}
	
	private function getState($statusName) {
	
		if ("Completed" == $statusName) {
			return Mage_Sales_Model_Order::STATE_COMPLETE;
		} else if ("Pending" == $statusName) {
			return Mage_Sales_Model_Order::STATE_NEW;
		} else if ("Pending Paypal" == $statusName) {
			return Mage_Sales_Model_Order::STATE_PENDING_PAYMENT;
		} else if ("Processing" == $statusName) {
			return Mage_Sales_Model_Order::STATE_PROCESSING;
		} else if ("Closed" == $statusName) {
			return Mage_Sales_Model_Order::STATE_CLOSED;
		} else if ("Canceled" == $statusName) {
			return Mage_Sales_Model_Order::STATE_CANCELED;
		} else if ("Holded" == $statusName) {
			return Mage_Sales_Model_Order::STATE_HOLDED;
		} else {
			return null;
		}
		
	}

}
